// Created:02-23-99
// By Jeff Connelly

// WinCompr I/O class

#ifndef __WCIO_H__
#define __WCIO_H__

#include "resource.h"
#define EXPORTING
#include "../comprlib.h"

class CWinComprIO : public ComprLibIOBase
{
public:
	// Source and destination files
	static FILE* m_source;
	static FILE* m_dest;

	// Bytes read, written, and progress control
	static CStatic* m_wndRead;
	static CStatic* m_wndWritten;
	static CProgressCtrl* m_wndProgress;
	
	// Bytes read and written
	static long m_lRead;
	static long m_lWritten;

	static void Set()
	{
		::read_byte = read_byte;
		::write_byte = write_byte;
		::beginning_of_data = beginning_of_data;
		::stream_size = stream_size;
		::end_of_data = end_of_data;
	}

	static void write_byte(unsigned char c)
	{
		CString str;

		m_lWritten++;
		
		putc(c, m_dest);
		str.Format("%d", m_lWritten);
		m_wndWritten->SetWindowText(str);
	}
	static unsigned char read_byte()
	{
		CString str;

		m_lRead++;

		unsigned char c;
		c = getc(m_source);
		str.Format("%d", m_lRead);
		m_wndProgress->StepIt();

		m_wndRead->SetWindowText(str);
		return c;
	}
	static void beginning_of_data()
	{
		m_lRead = 0;
		fseek(m_source, 0, SEEK_CUR);
		AfxGetMainWnd()->SendMessage(WM_SETSTATUS, IDS_STATUS_RESET);
		AfxMessageBox("Reset");
	}
	static long stream_size()
	{
		long old, ret;

		old = ftell(m_source);
		fseek(m_source, 0, SEEK_END);
		ret = ftell(m_source);
		fseek(m_source, old, SEEK_SET);
		return ret;
	}
	static BOOL end_of_data()
	{
		return ftell(m_source) >= stream_size();
		return feof(m_source);
	}
};
#endif